################################################################################
########################## Save scorecard image ################################
################################################################################


SC_save_image <- function(system.filename, reference.filename, var.name, var.filename, start.year, end.year, mod.pressure){
  
         plevel <- "" # TO DO: read from recipe
    
        start.year <- recipe$Analysis$Time$hcst_start ## 1993
        end.year <- recipe$Analysis$Time$hcst_end ## 2016
        var.name <- recipe$Analysis$Variables$name
        system.filename <- archive$System[[recipe$Analysis$Datasets$System$name]]$system_filename ## 'ecmwfs5'
        reference.filename <- archive$Reference[[recipe$Analysis$Datasets$Reference$name]]$reference_filename ## 'era5'
        var.filename <- recipe$Analysis$Variables$name ## 'tas'
        period <- paste0(start.year, "-", end.year)

        if(plevel==""){
          mod.pressure <- ""
          mod.pressure.title <- ""
        }else{
          plevel <- as.integer(plevel)
          mod.pressure <- paste0("-p", plevel)
          mod.pressure.title <- paste0(" at ", plevel, " hPa")
        }
        
        
        dirout <- save_scorecard_path(system.filename = archive$System[[recipe$Analysis$Datasets$System$name]]$system_filename, 
                                      reference.filename = archive$Reference[[recipe$Analysis$Datasets$Reference$name]]$reference_filename, 
                                      var.filename = recipe$Analysis$Variables$name, 
                                      start.year = recipe$Analysis$Time$hcst_start, 
                                      end.year = recipe$Analysis$Time$hcst_end, 
                                      period = paste0(start.year, "-", end.year),
                                      mod.pressure = mod.pressure,
                                      scorecard_type = scorecard_type)
            
        system(paste0("mv ", './scorecard.png', paste0(" ", dirout)))
        return(print(paste0("Scorecard ", scorecard_type, " (", scorecard_name, ") figure saved")))
        
        
        #setwd(currentworkingdir)

}



##### Image path to save function ######

save_scorecard_path <- function(system.filename, reference.filename, var.filename, start.year, end.year, mod.pressure, period, scorecard_type){
  
  if(plevel==""){
    scorecard_save_path <- paste0(fileout, "/", system.filename,
                                  "/scorecard-", scorecard_type, "_", system.filename, "_", reference.filename, "_",
                                  var.filename, "_", period, ".png")
  }else{
    scorecard_save_path <- paste0(fileout, "/", system.filename,
                                  "/scorecard-", scorecard_type, "_", system.filename, "_", reference.filename, "_",
                                  var.filename, "_", mod.pressure, "_", period, ".png")
    
  }
  return(scorecard_save_path)
  
}